package businessLogic;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class CookieManager 
{	
	private final static String CookieName = "userCookieOfMyWebsite"; // Le nom de mon Cookie
	
	public CookieManager() 
	{

	}
	
	public static boolean isUserLogged(HttpServletRequest request)
	{
		Cookie[] mesCookies = request.getCookies(); // Je rcupre tous les cookies
		if (mesCookies!=null) 
		{
			for (int i=0; i<mesCookies.length; i++) 
			{
				if (mesCookies[i].getName().equals(CookieName)) return true; // S'il existe un Cookie nomm "CookieName"
			}
		}
		return false;
	}
	
	public static String getKey(HttpServletRequest request)
	{
		String nom = "Unknown";
		Cookie[] mesCookies = request.getCookies(); 
		if (mesCookies!=null) 
		{
			for (int i=0; i<mesCookies.length; i++) 
			{
				if (mesCookies[i].getName().equals(CookieName))
				{
					nom = mesCookies[i].getValue(); // Je rcupre la valeur de ce Cookie
				}
			}
		}
		return nom;
	}
	
	public static void createCookie(HttpServletResponse response, String nom)
	{
		Cookie nom_du_Cookie= new Cookie(CookieName, nom);
		nom_du_Cookie.setMaxAge(24 * 60 * 60); // une journe de validit du Cookie
		response.addCookie(nom_du_Cookie);
	}

}
